Index: squid/port/win32/squid.dsw
diff -u squid/port/win32/squid.dsw:1.1.2.27 squid/port/win32/squid.dsw:1.1.2.27.2.2
--- squid/port/win32/squid.dsw:1.1.2.27	Sun May  1 00:50:11 2005
+++ squid/port/win32/squid.dsw	Sun Oct 30 01:22:28 2005
@@ -56,6 +56,9 @@
     Begin Project Dependency
     Project_Dep_Name doc
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name negotiate_auth
+    End Project Dependency
 }}}
 
 ###############################################################################
@@ -348,6 +351,21 @@
 
 ###############################################################################
 
+Project: "libnegotiate"=".\libnegotiate\libnegotiate.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name modules
+    End Project Dependency
+}}}
+
+###############################################################################
+
 Project: "libntlm"=".\libntlm\libntlm.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -447,6 +465,24 @@
 
 ###############################################################################
 
+Project: "negotiate_auth"=".\negotiate_auth\negotiate_auth.dsp" - Package Owner=<4>
+
+Package=<5>
+{{{
+}}}
+
+Package=<4>
+{{{
+    Begin Project Dependency
+    Project_Dep_Name libmiscutil
+    End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libsspwin32
+    End Project Dependency
+}}}
+
+###############################################################################
+
 Project: "nt_auth"=".\nt_auth\nt_auth.dsp" - Package Owner=<4>
 
 Package=<5>
@@ -557,6 +593,9 @@
     Begin Project Dependency
     Project_Dep_Name libnull
     End Project Dependency
+    Begin Project Dependency
+    Project_Dep_Name libnegotiate
+    End Project Dependency
 }}}
 
 ###############################################################################
Index: squid/port/win32/squid_mswin.mak
diff -u squid/port/win32/squid_mswin.mak:1.1.2.9 squid/port/win32/squid_mswin.mak:1.1.2.9.2.1
--- squid/port/win32/squid_mswin.mak:1.1.2.9	Sun Oct  2 08:22:21 2005
+++ squid/port/win32/squid_mswin.mak	Sat Oct  8 03:01:45 2005
@@ -46,7 +46,7 @@
 DEFAULT_MIB_PATH	= $(datadir)/mib.txt
 DEFAULT_HOSTS		= none
 
-AUTH_MODULES = basic ntlm digest
+AUTH_MODULES = basic ntlm digest negotiate
 REPL_POLICIES = lru heap
 STORE_MODULES = ufs awin32 null
 
Index: squid/port/win32/update.cmd
diff -u squid/port/win32/update.cmd:1.1.2.27 squid/port/win32/update.cmd:1.1.2.26.2.3
--- squid/port/win32/update.cmd:1.1.2.27	Tue Nov  8 06:44:26 2005
+++ squid/port/win32/update.cmd	Sat Mar 25 05:09:57 2006
@@ -21,6 +21,7 @@
 copy %0\..\nt_auth\%1\nt_auth.exe %2\libexec\win32_auth.exe
 copy %0\..\ncsa_auth\%1\ncsa_auth.exe %2\libexec\ncsa_auth.exe
 copy %0\..\ntlm_win32_auth\%1\ntlm_win32_auth.exe %2\libexec\win32_ntlm_auth.exe
+copy %0\..\negotiate_auth\%1\negotiate_auth.exe %2\libexec\win32_negotiate_auth.exe
 copy %0\..\ldap_auth\%1\ldap_auth.exe %2\libexec\squid_ldap_auth.exe
 copy %0\..\ldap_group\%1\ldap_group.exe %2\libexec\squid_ldap_group.exe
 copy %0\..\win32_check_group\%1\win32_check_group.exe %2\libexec\win32_check_group.exe
@@ -39,6 +40,7 @@
 
 copy %0\..\readme.txt %2\docs\readme.txt
 copy %0\..\..\..\helpers\ntlm_auth\NTLMSSP-WIN32\readme.txt %2\docs\win32_ntlm_auth.txt
+copy %0\..\..\..\helpers\negotiate_auth\Win32\readme.txt %2\docs\win32_negotiate_auth.txt
 copy %0\..\..\..\helpers\external_acl\win32_group\readme.txt %2\docs\win32_check_group.txt
 copy %0\..\..\..\helpers\external_acl\ip_user\README %2\docs\ip_user_check.txt
 copy %0\..\..\..\helpers\basic_auth\win32_locallogon\readme.txt %2\docs\win32_auth.txt
Index: squid/port/win32/libnegotiate/.cvsignore
diff -u /dev/null squid/port/win32/libnegotiate/.cvsignore:1.1.2.1
--- /dev/null		Thu Jan  1 01:00:00 1970
+++ squid/port/win32/libnegotiate/.cvsignore	Sat Oct  8 03:01:46 2005
@@ -0,0 +1,3 @@
+.cvsignore
+Debug
+Release
Index: squid/port/win32/negotiate_auth/.cvsignore
diff -u /dev/null squid/port/win32/negotiate_auth/.cvsignore:1.1.2.1
--- /dev/null		Thu Jan  1 01:00:00 1970
+++ squid/port/win32/negotiate_auth/.cvsignore	Sun Oct 30 01:22:28 2005
@@ -0,0 +1,3 @@
+.cvsignore
+Debug
+Release
Index: squid/src/authenticate.c
diff -u squid/src/authenticate.c:1.23.2.1.4.14 squid/src/authenticate.c:1.23.2.1.4.14.2.1
--- squid/src/authenticate.c:1.23.2.1.4.14	Mon Sep 19 09:23:07 2005
+++ squid/src/authenticate.c	Sat Oct  8 02:13:11 2005
@@ -763,11 +763,16 @@
 	    /* call each configured & running authscheme */
 	    for (i = 0; i < Config.authConfig.n_configured; i++) {
 		scheme = Config.authConfig.schemes + i;
-		if (authscheme_list[scheme->Id].Active())
-		    authscheme_list[scheme->Id].authFixHeader(NULL, rep, type,
-			request);
-		else
+		if (authscheme_list[scheme->Id].Active()) {
+		    if  (auth_user_request && scheme->Id == auth_user_request->auth_user->auth_module - 1)
+			authscheme_list[scheme->Id].authFixHeader(
+				auth_user_request, rep, type, request);
+		    else
+			authscheme_list[scheme->Id].authFixHeader(
+				NULL, rep, type, request);
+		} else {
 		    debug(29, 4) ("authenticateFixHeader: Configured scheme %s not Active\n", scheme->typestr);
+		}
 	    }
 	}
     }
Index: squid/src/cf.data.pre
diff -u squid/src/cf.data.pre:1.49.2.5.4.83 squid/src/cf.data.pre:1.49.2.5.4.80.2.5
--- squid/src/cf.data.pre:1.49.2.5.4.83	Sun Feb 26 01:14:42 2006
+++ squid/src/cf.data.pre	Sun Feb 26 01:52:30 2006
@@ -1337,11 +1337,11 @@
 	auth_param basic program @DEFAULT_PREFIX@/libexec/ncsa_auth @DEFAULT_PREFIX@/etc/passwd
 
 	"children" numberofchildren
-	The number of authenticator processes to spawn.
-	If you start too few Squid will have to wait for them to process a
-	backlog of usercode/password verifications, slowing it down. When
-	password verifications are done via a (slow) network you are likely to
-	need lots of authenticator processes.
+	The number of authenticator processes to spawn. If you start too few 
+	squid will have to wait for them to process a backlog of credential
+	verifications, slowing it down. When credential verifications are
+	done via a (slow) network you are likely to need lots of
+	authenticator processes.
 	auth_param basic children 5
 
 	"realm" realmstring
@@ -1393,11 +1393,11 @@
 
 
 	"children" numberofchildren
-	The number of authenticator processes to spawn (no default). If you
-	start too few Squid will have to wait for them to process a backlog of
-	H(A1) calculations, slowing it down.  When the H(A1) calculations are
-	done via a (slow) network you are likely to need lots of authenticator
-	processes.
+	The number of authenticator processes to spawn. If you start too few 
+	squid will have to wait for them to process a backlog of credential
+	verifications, slowing it down. When credential verifications are
+	done via a (slow) network you are likely to need lots of
+	authenticator processes.
 	auth_param digest children 5
 
 	"realm" realmstring
@@ -1454,27 +1454,13 @@
 	auth_param ntlm program /path/to/samba/bin/ntlm_auth --helper-protocol=squid-2.5-ntlmssp
 
 	"children" numberofchildren
-	The number of authenticator processes to spawn (no default). If you
-	start too few Squid will have to wait for them to process a backlog
-	of credential verifications, slowing it down. When credential
-	verifications are done via a (slow) network you are likely to need
-	lots of authenticator processes.
+	The number of authenticator processes to spawn. If you start too few 
+	squid will have to wait for them to process a backlog of credential
+	verifications, slowing it down. When credential verifications are
+	done via a (slow) network you are likely to need lots of
+	authenticator processes.
 	auth_param ntlm children 5
 
-	"max_challenge_reuses" number
-	The maximum number of times a challenge given by a ntlm authentication
-	helper can be reused. Increasing this number increases your exposure
-	to replay attacks on your network. 0 (the default) means use the
-	challenge is used only once. See also the max_ntlm_challenge_lifetime
-	directive if enabling challenge reuses.
-	auth_param ntlm max_challenge_reuses 0
-
-	"max_challenge_lifetime" timespan
-	The maximum time period a ntlm challenge is reused over. The
-	actual period will be the minimum of this time AND the number of
-	reused challenges.
-	auth_param ntlm max_challenge_lifetime 2 minutes
-
 	"use_ntlm_negotiate" on|off
 	Enables support for NTLM NEGOTIATE packet exchanges with the helper.
 	The configured ntlm authenticator must be able to handle NTLM
@@ -1489,29 +1475,67 @@
 	all users must be allowed to log on the proxy servers too, or they'll
 	get "invalid workstation" errors - and access denied - when trying to
 	use Squid's services.
-	Use of ntlm NEGOTIATE is incompatible with challenge reuse, so
-	enabling this parameter will OVERRIDE the max_challenge_reuses and
-	max_challenge_lifetime parameters and set them to 0.
-	auth_param ntlm use_ntlm_negotiate off
+	auth_param ntlm use_ntlm_negotiate on
+
+	"keep_alive" on|off
+	This option enables the use of keep-alive on the initial
+	authentication request. It has been reported some versions of MSIE
+	have problems if this is enabled, but performance will be increased
+	if enabled.
+
+	auth_param ntlm keep_alive on
+
+	=== Negotiate scheme options follow ===
+
+	"program" cmdline
+	Specify the command for the external Negotiate authenticator. Such a
+	program participates in the SPNEGO exchanges between Squid and the
+	client and reads commands according to the Squid ntlmssp helper
+	protocol. See helpers/ntlm_auth/ for details. Recommended SPNEGO
+	authenticator is ntlm_auth from Samba-4.X.
+
+	By default, the Negotiate authentication scheme is not used unless a
+	program is specified.
+
+	auth_param negotiate program /path/to/samba/bin/ntlm_auth --helper-protocol=gss-spnego
+
+	"children" numberofchildren
+	The number of authenticator processes to spawn. If you start too few 
+	squid will have to wait for them to process a backlog of credential
+	verifications, slowing it down. When credential verifications are
+	done via a (slow) network you are likely to need lots of
+	authenticator processes.
+	auth_param negotiate children 5
+
+	"keep_alive" on|off
+	If you experience problems with PUT/POST requests when using the
+	Negotiate authentication scheme then you can try setting this to
+	off. This will cause Squid to forcibly close the connection on
+	the initial requests where the browser asks which schemes are
+	supported by the proxy.
+
+	auth_param negotiate keep_alive on
 
 NOCOMMENT_START
-#Recommended minimum configuration:
+#Recommended minimum configuration per scheme:
+#auth_param negotiate program <uncomment and complete this line to activate>
+#auth_param negotiate children 5
+#auth_param negotiate keep_alive on
+#auth_param ntlm program <uncomment and complete this line to activate>
+#auth_param ntlm children 5
+#auth_param ntlm use_ntlm_negotiate on
+#auth_param ntlm keep_alive on
 #auth_param digest program <uncomment and complete this line>
 #auth_param digest children 5
 #auth_param digest realm Squid proxy-caching web server
 #auth_param digest nonce_garbage_interval 5 minutes
 #auth_param digest nonce_max_duration 30 minutes
 #auth_param digest nonce_max_count 50
-#auth_param ntlm program <uncomment and complete this line to activate>
-#auth_param ntlm children 5
-#auth_param ntlm max_challenge_reuses 0
-#auth_param ntlm max_challenge_lifetime 2 minutes
-#auth_param ntlm use_ntlm_negotiate off
 #auth_param basic program <uncomment and complete this line>
-auth_param basic children 5
-auth_param basic realm Squid proxy-caching web server
-auth_param basic credentialsttl 2 hours
-auth_param basic casesensitive off
+#auth_param basic children 5
+#auth_param basic realm Squid proxy-caching web server
+#auth_param basic credentialsttl 2 hours
+#auth_param basic casesensitive off
 NOCOMMENT_END
 DOC_END
 
Index: squid/src/enums.h
diff -u squid/src/enums.h:1.29.6.18 squid/src/enums.h:1.29.6.17.2.2
--- squid/src/enums.h:1.29.6.18	Sat Nov 12 00:43:36 2005
+++ squid/src/enums.h	Sat Nov 12 00:47:42 2005
@@ -534,6 +534,7 @@
     AUTH_BASIC,
     AUTH_NTLM,
     AUTH_DIGEST,
+    AUTH_NEGOTIATE,
     AUTH_BROKEN			/* known type, but broken data */
 } auth_type_t;
 
Index: squid/src/helper.c
diff -u squid/src/helper.c:1.16.10.24 squid/src/helper.c:1.16.10.23.2.3
--- squid/src/helper.c:1.16.10.24	Sat Mar 11 06:07:46 2006
+++ squid/src/helper.c	Sat Mar 11 08:58:58 2006
@@ -416,6 +416,8 @@
     helper_stateful_server *srv;
     dlink_node *link;
     double tt;
+    storeAppendPrintf(sentry, "program: %s\n",
+	hlp->cmdline->key);
     storeAppendPrintf(sentry, "number running: %d of %d\n",
 	hlp->n_running, hlp->n_to_start);
     storeAppendPrintf(sentry, "requests sent: %d\n",
@@ -741,6 +743,8 @@
     } else if ((t = strchr(srv->buf, '\n'))) {
 	/* end of reply found */
 	debug(84, 3) ("helperHandleRead: end of reply found\n");
+	if (t > srv->buf && t[-1] == '\r')
+	    t[-1] = '\0';
 	*t = '\0';
 	srv->flags.busy = 0;
 	srv->offset = 0;
@@ -798,6 +802,8 @@
     } else if ((t = strchr(srv->buf, '\n'))) {
 	/* end of reply found */
 	debug(84, 3) ("helperStatefulHandleRead: end of reply found\n");
+	if (t > srv->buf && t[-1] == '\r')
+	    t[-1] = '\0';
 	*t = '\0';
 	srv->flags.busy = 0;
 	srv->offset = 0;
Index: squid/src/auth/Makefile.am
diff -u squid/src/auth/Makefile.am:1.2.40.1 squid/src/auth/Makefile.am:1.2.40.1.2.1
--- squid/src/auth/Makefile.am:1.2.40.1	Sun Oct 27 02:46:15 2002
+++ squid/src/auth/Makefile.am	Sat Oct  8 02:13:11 2005
@@ -4,15 +4,16 @@
 #
 AUTOMAKE_OPTIONS = subdir-objects
 
-DIST_SUBDIRS	= basic digest ntlm
+DIST_SUBDIRS	= basic digest ntlm negotiate
 SUBDIRS		= @AUTH_MODULES@
 
-EXTRA_LIBRARIES	= libbasic.a libdigest.a libntlm.a
+EXTRA_LIBRARIES	= libbasic.a libdigest.a libntlm.a libnegotiate.a
 noinst_LIBRARIES	= @AUTH_LIBS@
 
 libbasic_a_SOURCES	= basic/auth_basic.c basic/auth_basic.h
 libdigest_a_SOURCES	= digest/auth_digest.c digest/auth_digest.h
 libntlm_a_SOURCES	= ntlm/auth_ntlm.c ntlm/auth_ntlm.h
+libnegotiate_a_SOURCES	= negotiate/auth_negotiate.c negotiate/auth_negotiate.h
 
 if ENABLE_WIN32SPECIFIC
 INCLUDES      = -I. -I$(top_srcdir)/port/win32/include -I$(top_srcdir)/include \
Index: squid/src/auth/negotiate/.cvsignore
diff -u /dev/null squid/src/auth/negotiate/.cvsignore:1.1.2.1
--- /dev/null		Thu Jan  1 01:00:00 1970
+++ squid/src/auth/negotiate/.cvsignore	Sat Oct  8 02:24:12 2005
@@ -0,0 +1,2 @@
+.cvsignore
+Makefile.in
Index: squid/src/auth/negotiate/Makefile.am
diff -u /dev/null squid/src/auth/negotiate/Makefile.am:1.1.6.2
--- /dev/null		Thu Jan  1 01:00:00 1970
+++ squid/src/auth/negotiate/Makefile.am	Sat Oct  8 02:24:12 2005
@@ -0,0 +1 @@
+SUBDIRS =
